/* struct stoppingpower
 * 
 * structure to hold the information from the stopping power file
 */
struct stoppingpower{
  float projmass;       // projectile mass
  float beamenergy;     // beam energy
  int targa,targz;      // target a and z
  int backa,backz;      // backing a and z
  /* --- for blaugrund's approx --- */
  int blauswitch;       // switch for blaugrund's approx
  int reca,recz;        // recoil a and z
  float recfwhmen;      // fractional FWHM of recoil energy dist. (e.g. recfwhmen = 0.25)
  int numrectheta;      // number of recoil theta angles
  int numrecphi;        // number of recoil phi angles
  float *rectheta;      // pointer to the recoil theta angles
  float *recphi;        // pointer to the recoil phi angles
  float *recprobtheta;  // pointer to the probablility of recoil at each theta angle.
  float detres[3];      // detector resolution (and angle?)
  float projstopnorm;   // projectile stopping power normalization
  float minbeamen;      // minimum beam energy
  float debeamen;       // energy increment for beam energy/stopping powers.
  int numprojstop;      // number of projectile stopping powers
  float *projstop;      // pointer to the projectile stopping powers.
  int numtarel;         // number of target elements
  float tarelthick;     // thickness of target elements
  float tardensity;     // density of target
  float tarstopnorm[2];    // target stopping power normalization
  int numcoarsestop;    // number of coarse stopping powers to read.
  int numrecoils[2];       // number of recoils
  float fn[2];          // god only knows
  float fe[2];          // god only knows
  int nchoice;          // god only knows
  float *stopen1;       // energy of the first coarse stopping power (electronic)
  float *stop1;         // stopping power of first coarse stopping power
  float *stopen2;       // energy of the second coarse stopping power (nuclear)
  float *stop2;         // stopping power of second coarse stopping power
  int numresidprodcross; // number of residual nucleus production cross-sections
  float *crosssectionen; // energy for the residual nucleus production cross section
  float *crosssection;  // cross sections for the residual nuclei.
  float theta;          // theta of the detector
  float a2;             // 2nd order angle correction
  float a4;             // 3rd order angle correction
  float r;              // detector geometry stuff.
  float h;
  float d;
  int nrad,nang;

};

struct fitsvariables {
  double spect[30][1200];       // spectrum
  double specn[30][1000],spec[30][1000],bestsp[10][1200];
  float cst[10][10][5][10],probn[10][10][5][10],qft[3],peakp[10];
  double gauss[200];
  float er[7],eprob[7],rnumi[7];
  float taul[30];
  int nlt,np1;
  int ich1,ichn,ibkg;
  float pklo,pkhi,dpeak,peakpos[10],ispece[100];
  int icmax;
  float nbest[10],bestt1[10],bestt2[10],bestchi[10],bestbk[10];
  int iblau;
  float cbar[600];
  int igmax;
  float ecal;
  float ntp,epfac[2],facnuke[2];
  float pop[4][10],tau[4][10],tsf[4][10];
  float acn;
  float tauup,taulo,dtau;
  float nlts;
  float egam;
  float dki[30];
};

