/*
 * File: gtksquiggle.h
 * Auth: John Pavan
*/
#ifndef __GTK_SQUIGGLE_H__
#define __GTK_SQUIGGLE_H__

#include <gdk/gdk.h>
#include <gtk/gtkvbox.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   * --- Macros for conversion and type checking
   */
  #define GTK_SQUIGGLE(obj) \
    GTK_CHECK_CAST (obj, gtk_squiggle_get_type(), GtkSquiggle)
  #define GTK_SQUIGGLE_CLASS(klass) \
    GTK_CHECK_CLASS_CAST (klass, gtk_squiggle_get_type, GtkSquiggleClass)
  #define GTK_IS_SQUIGGLE(obj) \
    GTK_CHECK_TYPE(obj, gtk_squiggle_get_type())

  /*
   * --- Defining data structures
   */

  typedef struct _GtkSquiggle                GtkSquiggle;
  typedef struct _GtkSquiggleClass   GtkSquiggleClass;

  /*
   * --- Here's the squiggle data
   */

  struct _GtkSquiggle
  {
    gint num_segments;
    GdkPoint *segments;
  };

  /*
   * Here's the class data
   */

  struct _GtkSquiggleClass
  {
    GtkWidgetClass parent_class;
  };

  /*
   * Function prototypes
   */
  GtkWidget* gtk_squiggle_new(void);
  void gtk_squiggle_size (GtkSquiggle *squiggle, int xsize, int ysize);
  void gtk_squiggle_set_value (GtkSquiggle *squiggle, int xindex, int yindex, int value);
  void gtk_squiggle_title (GtkSquiggle *squiggle,const char *title);
  void gtk_squiggle_clear_segments(GtkSquiggle *squiggle);
  void gtk_squiggle_add_segment(GtkSquiggle *squiggle,GdkPoint *point);
  int gtk_squiggle_has_segements(GtkSquiggle *squiggle);
  #ifdef __cplusplus
}
#endif */ __cplusplus */

#endif */ __GTK_SQUIGGLE_H__ */

