#include <gtk/gtk.h>

/* --- Must declare all functions used in menu here --- */

static void ShowMenu (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void QuitApp(gpointer callback_data, guint callback_action, GtkWidget *widget);
static void SetType (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void SetPlotType (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadFile (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuWriteFile (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuDisplayPlot (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuDisplayPlotSameRange (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuExpandPlot (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuManualMarkSet (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuShiftLeft (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuShiftRight (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuNextSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPrevSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSetYScale (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuYScaleUp (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuYScaleDown (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSetBackground (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuManualSetBackground (gpointer callback_data, 
				     guint callback_action, GtkWidget *widget);
static void MenuOneChSetBackground (gpointer callback_data, 
				    guint callback_action, GtkWidget *widget);
static void MenuZoomOut (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuGetCalibration (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuManualExpandPlot (gpointer callback_data, 
				  guint callback_action, GtkWidget *widget);
static void MenuGetSum (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuAddSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuMoveSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuCompressSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuTitleSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSubtractSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuNormalizeSpectra (gpointer callback_data, 
				  guint callback_action, GtkWidget *widget);
static void MenuGainshiftSpectra (gpointer callback_data, 
				  guint callback_action, GtkWidget *widget);
static void MenuGaussFit (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuClearSpectra (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuRedraw (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuDoubleGaussFit (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuActiveUp (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuActiveDown (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuFixedWidthGaussFit (gpointer callback_data, 
				    guint callback_action, GtkWidget *widget);
static void MenuLiphaFile (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadGS (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuWriteGS (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuProject (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuProjectFull (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuManualProject (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSetup (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSort (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuHelp (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuAbout (gpointer callback_data, guint callback_action, GtkWidget *widget);
//static void MenuListBetweenMarkers (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadBig (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuSetEfficiency (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuDisplayBig (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadPGAMSetup (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadPGAMMasterSetup (gpointer callback_data, 
                                     guint callback_action, GtkWidget *widget);
static void MenuPGAMSort (gpointer callback_data, guint callback_action, GtkWidget *widget);

static void MenuWritePgamTwod (gpointer callback_data, 
			      guint callback_action, GtkWidget *widget);
static void MenuReadPgamTwod (gpointer callback_data, 
			      guint callback_action, GtkWidget *widget);
static void MenuTwodProjectFull (gpointer callback_data, 
				     guint callback_action, GtkWidget *widget);
static void MenuProjectionBox (gpointer callback_data, 
				     guint callback_action, GtkWidget *widget);
static void MenuWriteBig (gpointer callback_data, guint callback_action, GtkWidget *widget);
//static void MenuReadStop (gpointer callback_data, guint callback_action, GtkWidget *widget);
//static void MenuMakeFeedingWindow (gpointer callback_data, 
//				   guint callback_action, GtkWidget *widget);
//static void MenuReadFitsSetup (gpointer callback_data, guint callback_action, GtkWidget *widget);
//static void MenuFits (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuMultipleToSingleFast (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuExpFit (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPeakFit (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuReadCalibInfo (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPrint (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPrintToFile (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuMultiInOne (gpointer callback_data, guint callback_action, GtkWidget *widget);
static void MenuPgamMatrix2Big(gpointer callback_data,
			       guint callback_action, GtkWidget *widget);
static void MenuSpecULator(gpointer callback_data,
			       guint callback_action, GtkWidget *widget);
static void MenuAutoReadMatrix(gpointer callback_data,
			       guint callback_action, GtkWidget *widget);
static void MenuAutoWriteMatrix(gpointer callback_data,
			       guint callback_action, GtkWidget *widget);
static void MenuReadPgamAdd(gpointer callback_data,
			    guint callback_action, GtkWidget *widget);
static void MenuReadPgamSub(gpointer callback_data,
			    guint callback_action, GtkWidget *widget);
static void MenuSetYScaleMode(gpointer callback_data,
			    guint callback_action, GtkWidget *widget);
static void MenuWriteRadwareMatrix(gpointer callback_data,
			    guint callback_action, GtkWidget *widget);
static void MenuCompress2(gpointer callback_data,
			    guint callback_action, GtkWidget *widget);
static void MenuSetBackgroundPoly(gpointer callback_data,
				  guint callback_action, GtkWidget *widget);

/*
 * Structure to build the menus
 */
static GtkItemFactoryEntry menu_items[] = {
  {"/_File",                        NULL,         0,              0,  "<Branch>"},
  {"/File/tearoff1",                NULL,         ShowMenu,       0,  "<Tearoff>"},
  {"/File/_Read",                   "R",          MenuReadFile,   0 },
  {"/File/_Write Histograms",       "W",          MenuWriteFile,  0 },
  {"/File/Write _Lipha",            "L",          MenuLiphaFile,  0 },
  {"/File/Write _2D Histograms",     NULL,         MenuWriteBig,0},
  {"/File/Write _Matrix",            NULL,         MenuAutoWriteMatrix, 0},
  {"/File/Compress MUL",            NULL,         MenuCompress2, 0}, 
  {"/File/tearoff2",                NULL,         0,             0, "<Tearoff>"},
  {"/File/_Print",                   "<control>P", MenuPrint,      0,},
  {"/File/Print to _File",           NULL, MenuPrintToFile,      0,},
  {"/File/tearoff3",                NULL,         0,             0, "<Tearoff>"},
  {"/File/_Quit",                   "<control>Q",          QuitApp,        0 },

  {"/_Manipulate",                  NULL,         0,              0,  "<Branch>"},
  {"/Manipulate/_Add",              "<control>A", MenuAddSpectra, 0, },
  {"/Manipulate/_Compress",         "<control>C", MenuCompressSpectra, 0, },
  {"/Manipulate/_Gainshift",        "<control>G", MenuGainshiftSpectra, 0, },
  {"/Manipulate/_Move",             "<control>M", MenuMoveSpectra,0, },
  {"/Manipulate/_Normalize",        "<control>N", MenuNormalizeSpectra, 0, },
  {"/Manipulate/_Subtract",         "<control>S", MenuSubtractSpectra, 0, },
  {"/Manipulate/_Title",            "<control>T", MenuTitleSpectra, 0, },
  {"/Manipulate/_Clear",            "<control>C", MenuClearSpectra, 0, },
  {"/Manipulate/tearoff1",          NULL, 0,0,"<Tearoff>"},
  {"/Manipulate/Spec-_U-Lator",     "F12",        MenuSpecULator, 0,},

  {"/_Display",                     NULL,         0,              0, "<Branch>"},
  {"/Display/_Display",             "D",          MenuDisplayPlot,0 },
  {"/Display/Display_Overlayed",        "<control>D", MenuMultiInOne,0},
  {"/Display/_Change Spectrum",    "<shift>D",    MenuDisplayPlotSameRange,0 },
  {"/Display/M -> S fast",          "Z",          MenuMultipleToSingleFast,0},
  {"/Display/tearoff1",            NULL,0,0,"<Tearoff>"},
  {"/Display/Calibration",          "K",          MenuGetCalibration, 0},
  {"/Display/Set Efficiency",       NULL,         MenuSetEfficiency, 0 },
  {"/Display/tearoff2",             NULL,0,0,"<Tearoff>"},
  {"/Display/_Type",                NULL,         0,              0, "<Branch>"},
  {"/Display/Type/_Linear",         NULL,         SetPlotType,    0, "<RadioItem>" },
  {"/Display/Type/_Log",            NULL,         SetPlotType,    0, "<RadioItem>" },
  {"/Display/Type/_Root",           NULL,         SetPlotType,    0, "<RadioItem>" },
  {"/Display/Type/_Efficency Corrected",           NULL,         SetPlotType,    0, "<RadioItem>" },
  {"/Display/_Mark",                "M",          MenuManualMarkSet,       0 },
  {"/Display/_Expand",              "E",          MenuExpandPlot, 0 },
  {"/Display/Manual Expand",        "<shift>E",   MenuManualExpandPlot, 0},
  {"/Display/Zoom _Out",            "O",          MenuZoomOut,    0 },
  {"/Display/Slide Right",          NULL,         MenuShiftRight, 0 },
  {"/Display/Slide Left",           NULL,         MenuShiftLeft,  0 },
  {"/Display/Next Spectrum",        NULL,         MenuNextSpectra,0 },
  {"/Display/Prev Spectrum",        NULL,         MenuPrevSpectra,0 },
  {"/Display/Range",                NULL,         0,              0, "<Branch>" },
  {"/Display/Range/Set Y Max",      "Y",          MenuSetYScale,  0 },
  {"/Display/Range/Scale Up",       NULL,         MenuYScaleDown,   0 },
  {"/Display/Range/Scale Down",     NULL,         MenuYScaleUp, 0 },
  {"/Display/Overlay Mode",         NULL,         0,              0, "<Branch>"},
  {"/Display/Overlay Mode/Auto Y Scale Off", NULL,MenuSetYScaleMode,  0 },
  {"/Display/Overlay Mode/Auto Y Scale On", NULL, MenuSetYScaleMode,  1 },
  {"/Display/Redraw",               "N",          MenuRedraw,     0 },
  {"/Display/Active Spectrum Up",   NULL,         MenuActiveUp,   0 },
  {"/Display/Active Spectrum Down", NULL,         MenuActiveDown, 0 },

  {"/_Analysis",                    NULL,         0,              0, "<Branch>"},
  {"/Analysis/_Gaussian",           "G",          MenuGaussFit,   0 },
  {"/Analysis/_Double Gausian",      "<shift>G",   MenuDoubleGaussFit, 0 },
  {"/Analysis/_Fixed FWHM Gausian",  "<control>G", MenuFixedWidthGaussFit, 0 },
  {"/Analysis/_Sum",                "S",          MenuGetSum,       0 },
  {"/Analysis/sep2",                NULL,         ShowMenu,       0, "<Separator>"},
  {"/Analysis/Set _Background",      "B",          MenuSetBackground, 0 },
  {"/Analysis/_Manual Set Background","<alt>B",    MenuManualSetBackground,       0},
  {"/Analysis/S_ingle Channel Background","<shift>B", MenuOneChSetBackground,  0},
  {"/Analysis/sep3",                 NULL,0,0,"<Tearoff>"},
  {"/Analysis/_Exponential Fit",     "X",          MenuExpFit, 0},
  {"/Analysis/_Peak Fit",            NULL,          MenuPeakFit, 0},
  {"/Analysis/Read _Calib Info",     NULL,          MenuReadCalibInfo, 0},
  {"/Analysis/Background _Poly",     NULL,         0,              0, "<Branch>"},
  {"/Analysis/Background Poly/_Constant", NULL,         MenuSetBackgroundPoly,       0 },
  {"/Analysis/Background Poly/_Linear", NULL,         MenuSetBackgroundPoly,       1 },
  {"/Analysis/Background Poly/_Quadratic", NULL,         MenuSetBackgroundPoly,       2 },

  {"/_Sort",                         NULL,          0,            0, "<Branch>"},
  {"/Sort/GS92 Sort Setup",              NULL,         MenuSetup,      0 },
  {"/Sort/GS92 Sort",                    NULL,         MenuSort,      0 },
  {"/Sort/PGAM S_ort",                   NULL,         MenuPGAMSort,    0},

  //  {"/_FITS",                         NULL,          0,               0, "<Branch>"},
  //{"/FITS/List",                    NULL,          MenuListBetweenMarkers,0},
  //  {"/FITS/Read Stopping Powers",    NULL,          MenuReadStop, 0},
  //  {"/FITS/Make Feeding Window",     NULL,          MenuMakeFeedingWindow,0},
  //  {"/FITS/Read Fits Setup",         NULL,          MenuReadFitsSetup,0},
  //  {"/FITS/Fits",                    NULL,          MenuFits, 0},

  {"/_2D Histograms",                         NULL,          0,               0, "<Branch>"},
  {"/2D Histograms/Display",             NULL,          MenuDisplayBig,     0, }, 
  {"/2D Histograms/Histogram Matrix",            NULL,          MenuPgamMatrix2Big, 0},

  {"/_Matrix",                  NULL,          0,               0, "<Branch>"},
  {"/Matrix/_Projection",                  "P",           MenuProjectionBox, 0},
  {"/Matrix/Histogram Matrix",            NULL,          MenuPgamMatrix2Big, 0},
  {"/Matrix/Add Matrix",                  NULL,          MenuReadPgamAdd,    0},
  {"/Matrix/Subtract Matrix",                  NULL,          MenuReadPgamSub,    0},

  {"/_Radware",                 NULL,          0,0,"<Branch>"},
  {"/Radware/Write Matrix",     NULL,          MenuWriteRadwareMatrix, 0},

  {"/D_egraded",                     NULL,          0,               0, "<Branch>"},
  {"/Degraded/_Read Matrix",          NULL,          MenuAutoReadMatrix, 0},
  {"/Degraded/Check _Setup File",             NULL,         MenuReadPGAMSetup, 0},
  {"/Degraded/Read _Master Setup",      NULL,         MenuReadPGAMMasterSetup, 0},
  {"/Degraded/Read Big",                NULL,          MenuReadBig,     0, },
  {"/Degraded/File _Type",                   NULL,         0,              0, "<Branch>" },
  {"/Degraded/File Type/Binary _.spk",       NULL,         SetType,        0, "<RadioItem>" },
  {"/Degraded/File Type/Binary _.nsm",       NULL,         SetType,        0, "<RadioItem>" },
  {"/Degraded/File Type/ASCii _.spk",        NULL,         SetType,        0, "<RadioItem>" },
  {"/Degraded/File Type/ASCii _.nsm",        NULL,         SetType,        0, "<RadioItem>" },
  {"/Degraded/File Type/General _ASCii",     NULL,         SetType,        0, "<RadioItem>" },

  {"/_Help",                        NULL,          0,               0, "<Branch>"},
  {"/Help/_Help",                   NULL,          MenuHelp,        0},
  {"/Help/_About",                  NULL,          MenuAbout,       0},

};
